package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsDiscountUserGiveRecordExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsDiscountUserGiveRecordExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdIsNull() {
            addCriterion("discount_user_id is null");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdIsNotNull() {
            addCriterion("discount_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdEqualTo(Long value) {
            addCriterion("discount_user_id =", value, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdNotEqualTo(Long value) {
            addCriterion("discount_user_id <>", value, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdGreaterThan(Long value) {
            addCriterion("discount_user_id >", value, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("discount_user_id >=", value, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdLessThan(Long value) {
            addCriterion("discount_user_id <", value, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdLessThanOrEqualTo(Long value) {
            addCriterion("discount_user_id <=", value, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdIn(List<Long> values) {
            addCriterion("discount_user_id in", values, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdNotIn(List<Long> values) {
            addCriterion("discount_user_id not in", values, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdBetween(Long value1, Long value2) {
            addCriterion("discount_user_id between", value1, value2, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountUserIdNotBetween(Long value1, Long value2) {
            addCriterion("discount_user_id not between", value1, value2, "discountUserId");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeIsNull() {
            addCriterion("discount_stock_code is null");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeIsNotNull() {
            addCriterion("discount_stock_code is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeEqualTo(Long value) {
            addCriterion("discount_stock_code =", value, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeNotEqualTo(Long value) {
            addCriterion("discount_stock_code <>", value, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeGreaterThan(Long value) {
            addCriterion("discount_stock_code >", value, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeGreaterThanOrEqualTo(Long value) {
            addCriterion("discount_stock_code >=", value, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeLessThan(Long value) {
            addCriterion("discount_stock_code <", value, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeLessThanOrEqualTo(Long value) {
            addCriterion("discount_stock_code <=", value, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeIn(List<Long> values) {
            addCriterion("discount_stock_code in", values, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeNotIn(List<Long> values) {
            addCriterion("discount_stock_code not in", values, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeBetween(Long value1, Long value2) {
            addCriterion("discount_stock_code between", value1, value2, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andDiscountStockCodeNotBetween(Long value1, Long value2) {
            addCriterion("discount_stock_code not between", value1, value2, "discountStockCode");
            return (Criteria) this;
        }

        public Criteria andSendUserIdIsNull() {
            addCriterion("send_user_id is null");
            return (Criteria) this;
        }

        public Criteria andSendUserIdIsNotNull() {
            addCriterion("send_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andSendUserIdEqualTo(Long value) {
            addCriterion("send_user_id =", value, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdNotEqualTo(Long value) {
            addCriterion("send_user_id <>", value, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdGreaterThan(Long value) {
            addCriterion("send_user_id >", value, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("send_user_id >=", value, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdLessThan(Long value) {
            addCriterion("send_user_id <", value, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdLessThanOrEqualTo(Long value) {
            addCriterion("send_user_id <=", value, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdIn(List<Long> values) {
            addCriterion("send_user_id in", values, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdNotIn(List<Long> values) {
            addCriterion("send_user_id not in", values, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdBetween(Long value1, Long value2) {
            addCriterion("send_user_id between", value1, value2, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserIdNotBetween(Long value1, Long value2) {
            addCriterion("send_user_id not between", value1, value2, "sendUserId");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneIsNull() {
            addCriterion("send_user_phone is null");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneIsNotNull() {
            addCriterion("send_user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneEqualTo(String value) {
            addCriterion("send_user_phone =", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneNotEqualTo(String value) {
            addCriterion("send_user_phone <>", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneGreaterThan(String value) {
            addCriterion("send_user_phone >", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("send_user_phone >=", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneLessThan(String value) {
            addCriterion("send_user_phone <", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("send_user_phone <=", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneLike(String value) {
            addCriterion("send_user_phone like", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneNotLike(String value) {
            addCriterion("send_user_phone not like", value, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneIn(List<String> values) {
            addCriterion("send_user_phone in", values, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneNotIn(List<String> values) {
            addCriterion("send_user_phone not in", values, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneBetween(String value1, String value2) {
            addCriterion("send_user_phone between", value1, value2, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andSendUserPhoneNotBetween(String value1, String value2) {
            addCriterion("send_user_phone not between", value1, value2, "sendUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdIsNull() {
            addCriterion("receive_user_id is null");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdIsNotNull() {
            addCriterion("receive_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdEqualTo(Long value) {
            addCriterion("receive_user_id =", value, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdNotEqualTo(Long value) {
            addCriterion("receive_user_id <>", value, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdGreaterThan(Long value) {
            addCriterion("receive_user_id >", value, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("receive_user_id >=", value, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdLessThan(Long value) {
            addCriterion("receive_user_id <", value, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdLessThanOrEqualTo(Long value) {
            addCriterion("receive_user_id <=", value, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdIn(List<Long> values) {
            addCriterion("receive_user_id in", values, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdNotIn(List<Long> values) {
            addCriterion("receive_user_id not in", values, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdBetween(Long value1, Long value2) {
            addCriterion("receive_user_id between", value1, value2, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserIdNotBetween(Long value1, Long value2) {
            addCriterion("receive_user_id not between", value1, value2, "receiveUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneIsNull() {
            addCriterion("receive_user_phone is null");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneIsNotNull() {
            addCriterion("receive_user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneEqualTo(String value) {
            addCriterion("receive_user_phone =", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneNotEqualTo(String value) {
            addCriterion("receive_user_phone <>", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneGreaterThan(String value) {
            addCriterion("receive_user_phone >", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("receive_user_phone >=", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneLessThan(String value) {
            addCriterion("receive_user_phone <", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("receive_user_phone <=", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneLike(String value) {
            addCriterion("receive_user_phone like", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneNotLike(String value) {
            addCriterion("receive_user_phone not like", value, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneIn(List<String> values) {
            addCriterion("receive_user_phone in", values, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneNotIn(List<String> values) {
            addCriterion("receive_user_phone not in", values, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneBetween(String value1, String value2) {
            addCriterion("receive_user_phone between", value1, value2, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveUserPhoneNotBetween(String value1, String value2) {
            addCriterion("receive_user_phone not between", value1, value2, "receiveUserPhone");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}